@echo off
SetLocal EnableExtensions
cd /d "%~dp0"

:: SETTINGS

:: path to your compiler
set compiler=d:\dev\SourceMod\addons\sourcemod\scripting\spcomp.exe

:: FTP server ip/domain, login, pass, root folder name
set ftp=ftp://user:password@ftp.domain.com/left4dead/

:: Specify true if you want to upload source files (.sp) as well
set upload_source=false

:: Subfolders in your FTP
set scripting=addons/sourcemod/scripting/
set plugins=addons/sourcemod/plugins/
set translations=addons/sourcemod/translations/
set data=addons/sourcemod/data/

:: path to file with a list of full paths to the one ore more plugins (.sp or .smx) on each line
set PluginList=plugins.txt


echo. ---------------------------------------------------
echo.    SM Plugins FTP uploader by Alex Dragokas v1.2
echo. ---------------------------------------------------
echo.
title sm plugins uploader

call :SaveTime

:loop
  for /f "UseBackQ delims=" %%c in ("%PluginList%") do (
  for %%a in ("%%~c") do (
    for /f "delims=" %%b in ('"2>NUL forfiles /p %%~dpsa /m "%%~nxa" /c "cmd /c echo @ftime""') do call :CheckTime "%%~a" "%%b"
  ))
  set /p=.<NUL
  ping -n 2 127.1 >NUL
goto loop

:SaveTime [opt.Path]
  if "%~1" neq "" (
    echo.
    echo [Time is saved] "%~nx1"
    for /f "delims=" %%b in ('"2>NUL forfiles /p %~dps1 /m "%~nx1" /c "cmd /c echo @ftime""') do set "%~nx1=%%b"
  ) else (
    for /f "UseBackQ delims=" %%c in ("%PluginList%") do (
    for %%a in ("%%~c") do (
      if not exist "%%~a" (
        echo [ERROR] File is no more exists: "%%~a"
      ) else (
        echo [Time is saved] "%%~nxa"
        for /f "delims=" %%b in ('"forfiles /p %%~dpsa /m "%%~nxa" /c "cmd /c echo @ftime""') do set "%%~nxa=%%b"
      )
    ))
  )
exit /b

:CheckTime [PlugPath] [NewTime]
  set "OldTime="
  for /f "tokens=1* delims==" %%a in ('2^>NUL set %~nx1') do set OldTime=%%b
  if not defined OldTime (call :SaveTime "%~1" & exit /b)
  set "NewTime=%~2"
  if "%OldTime%" neq "%NewTime%" (
    echo.
    echo "%~nx1" =^> MODIFIED
    call :SaveTime "%~1"
    if /i "%~x1"==".sp" (
      call :Compile "%~1"
      if errorlevel 1 (echo [ERROR] during compilation.) else (
        call :UploadFTP "%~dpn1.smx" "%plugins%"
        if /i "%upload_source%"=="true" call :UploadFTP "%~1" "%scripting%"
      )
    ) else (
    if /i "%~x1"==".smx" (
      call :UploadFTP "%~1" "%plugins%"
    ) else (
      call :IsTranslationFile "%~1"
      if not errorlevel 1 (
        call :UploadFTP "%~1" "%translations%"
      ) else (
        call :UploadFTP "%~1" "%data%"
      )
    ))
  )
exit /b

:IsTranslationFile [filename]
  for %%a in ("%~1") do if /i "%%~xa"==".txt" for %%b in ("%%~na") do if /i "%%~xb"==".phrases" exit /b 0
exit /b 1

:Compile [source]
  pushd "%~dp1"
  echo Compiling ...
  "%compiler%" "%~1" >NUL && (popd & exit /b 0)
  popd
exit /b 1

:UploadFTP [local file] [ftp subfolder]
  echo Uploading ...
  curl -# --upload-file "%~1" %ftp%/%~2|| echo [ERROR] during upload.
exit /b

:: to get more info on curl connections, add -v switch to its command line.
:: to connect to ftps securely, add switch --cacert "cacert.pem" and provide correct cacert.pem file with certificates.
:: to connect to ftps bypassing security (without certificate), add switch --insecure
